<?php

namespace NoccyLabs\SimpleJWT\Key;


class JWTDerivedKeyTest extends \PHPUnit\Framework\TestCase
{
    /**
     * @covers 
     */
    public function testTheDerivedKeysShouldBeConsistent()
    {
        $key1a = new JWTDerivedKey("foo", "foosalt");
        $key1b = new JWTDerivedKey("foo", "foosalt");
        $this->assertNotNull($key1a);
        $this->assertEquals($key1a->getBinaryKey(), $key1b->getBinaryKey());

        $key2a = new JWTDerivedKey("bar", "foosalt");
        $key2b = new JWTDerivedKey("bar", "barsalt");
        $key2c = new JWTDerivedKey("bar", "barsalt");
        $this->assertNotNull($key2a);
        $this->assertNotEquals($key2a->getBinaryKey(), $key2b->getBinaryKey());
        $this->assertEquals($key2b->getBinaryKey(), $key2c->getBinaryKey());
    }

    /**
     * @covers 
     */
    public function testTheDerivedKeysShouldBeUnique()
    {
        $keys = [];
        $keys[] = (new JWTDerivedKey("foo", "foosalt"))->getBinaryKey();
        $keys[] = (new JWTDerivedKey("foo", "barsalt"))->getBinaryKey();
        $keys[] = (new JWTDerivedKey("foo", "bazsalt"))->getBinaryKey();
        $keys[] = (new JWTDerivedKey("bar", "foosalt"))->getBinaryKey();
        $keys[] = (new JWTDerivedKey("bar", "barsalt"))->getBinaryKey();
        $keys[] = (new JWTDerivedKey("bar", "bazsalt"))->getBinaryKey();

        $unique = array_unique($keys);
        $this->assertEquals(count($keys), count($unique));
    }

}
